broadcom 80211 kernel panic in wlc_ampdu.c

Bug #730215 reported by Mohegan
34
This bug affects 6 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
High
Unassigned
linux-firmware (Ubuntu)
Undecided
Tim Gardner

Bug Description

Binary package hint: linux-firmware

I have many kernel panics with the brcml80211 module. My network controller is BCM43224.
I can use my computer only few minutes with this module (but it works with another module "wl").
---
AlsaVersion: Advanced Linux Sound Architecture Driver Version 1.0.23.
Architecture: amd64
ArecordDevices:
 **** List of CAPTURE Hardware Devices ****
 card 0: Intel [HDA Intel], device 0: STAC92xx Analog [STAC92xx Analog]
   Subdevices: 1/1
   Subdevice #0: subdevice #0
AudioDevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC0: jack 1470 F.... pulseaudio
CRDA: Error: [Errno 2] Aucun fichier ou dossier de ce type
Card0.Amixer.info:
 Card hw:0 'Intel'/'HDA Intel at 0xb6100000 irq 49'
   Mixer name : 'IDT 92HD81B1X5'
   Components : 'HDA:111d7605,103c144d,00100402'
   Controls : 14
   Simple ctrls : 9
Card1.Amixer.info:
 Card hw:1 'Generic'/'HD-Audio Generic at 0xb6020000 irq 50'
   Mixer name : 'ATI R6xx HDMI'
   Components : 'HDA:1002aa01,00aa0100,00100200'
   Controls : 4
   Simple ctrls : 1
Card1.Amixer.values:
 Simple mixer control 'IEC958',0
   Capabilities: pswitch pswitch-joined penum
   Playback channels: Mono
   Mono: Playback [on]
DistroRelease: Ubuntu 11.04
HibernationDevice: RESUME=UUID=62e39a2b-d3ab-4b67-925e-005e67c1e10e
MachineType: Hewlett-Packard HP ENVY 17 Notebook PC
Package: linux (not installed)
ProcEnviron:
 LANGUAGE=fr_FR:en
 LANG=fr_FR.UTF-8
 SHELL=/bin/bash
ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-2.6.38-7-generic root=UUID=28ac122a-234c-4507-83e0-2383ba62b536 ro elevator=deadline quiet splash vt.handoff=7
ProcVersionSignature: Ubuntu 2.6.38-7.39-generic 2.6.38
Regression: No
RelatedPackageVersions:
 linux-restricted-modules-2.6.38-7-generic N/A
 linux-backports-modules-2.6.38-7-generic N/A
 linux-firmware 1.49
Reproducible: Yes
StagingDrivers: brcm80211
Tags: natty running-unity kernel-config needs-upstream-testing staging
Title: [STAGING]
Uname: Linux 2.6.38-7-generic x86_64
UpgradeStatus: No upgrade log present (probably fresh install)
UserGroups: adm admin cdrom dialout lpadmin plugdev sambashare
dmi.bios.date: 11/03/2010
dmi.bios.vendor: Hewlett-Packard
dmi.bios.version: F.1B
dmi.board.asset.tag: Base Board Asset Tag
dmi.board.name: 144D
dmi.board.vendor: Hewlett-Packard
dmi.board.version: 65.35
dmi.chassis.type: 10
dmi.chassis.vendor: Hewlett-Packard
dmi.chassis.version: N/A
dmi.modalias: dmi:bvnHewlett-Packard:bvrF.1B:bd11/03/2010:svnHewlett-Packard:pnHPENVY17NotebookPC:pvr058E110000241920001620000:rvnHewlett-Packard:rn144D:rvr65.35:cvnHewlett-Packard:ct10:cvrN/A:
dmi.product.name: HP ENVY 17 Notebook PC
dmi.product.version: 058E110000241920001620000
dmi.sys.vendor: Hewlett-Packard

Revision history for this message
Mohegan (jack-mohegan) wrote :

lsci:
<<
00:00.0 Host bridge: Intel Corporation Core Processor DRAM Controller (rev 02)
00:01.0 PCI bridge: Intel Corporation Core Processor PCI Express x16 Root Port (rev 02)
00:16.0 Communication controller: Intel Corporation 5 Series/3400 Series Chipset HECI Controller (rev 06)
00:1a.0 USB Controller: Intel Corporation 5 Series/3400 Series Chipset USB2 Enhanced Host Controller (rev 05)
00:1b.0 Audio device: Intel Corporation 5 Series/3400 Series Chipset High Definition Audio (rev 05)
00:1c.0 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 1 (rev 05)
00:1c.1 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 2 (rev 05)
00:1c.2 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 3 (rev 05)
00:1d.0 USB Controller: Intel Corporation 5 Series/3400 Series Chipset USB2 Enhanced Host Controller (rev 05)
00:1e.0 PCI bridge: Intel Corporation 82801 Mobile PCI Bridge (rev a5)
00:1f.0 ISA bridge: Intel Corporation Mobile 5 Series Chipset LPC Interface Controller (rev 05)
00:1f.2 SATA controller: Intel Corporation 5 Series/3400 Series Chipset 4 port SATA AHCI Controller (rev 05)
00:1f.3 SMBus: Intel Corporation 5 Series/3400 Series Chipset SMBus Controller (rev 05)
00:1f.6 Signal processing controller: Intel Corporation 5 Series/3400 Series Chipset Thermal Subsystem (rev 05)
01:00.0 VGA compatible controller: ATI Technologies Inc Broadway PRO [Mobility Radeon HD 5800 Series]
01:00.1 Audio device: ATI Technologies Inc Juniper HDMI Audio [Radeon HD 5700 Series]
02:00.0 Network controller: Broadcom Corporation BCM43224 802.11a/b/g/n (rev 01)
03:00.0 Ethernet controller: Realtek Semiconductor Co., Ltd. RTL8111/8168B PCI Express Gigabit Ethernet controller (rev 03)
04:00.0 USB Controller: NEC Corporation uPD720200 USB 3.0 Host Controller (rev 03)
7f:00.0 Host bridge: Intel Corporation Core Processor QuickPath Architecture Generic Non-core Registers (rev 02)
7f:00.1 Host bridge: Intel Corporation Core Processor QuickPath Architecture System Address Decoder (rev 02)
7f:02.0 Host bridge: Intel Corporation Core Processor QPI Link 0 (rev 02)
7f:02.1 Host bridge: Intel Corporation Core Processor QPI Physical 0 (rev 02)
7f:02.2 Host bridge: Intel Corporation Core Processor Reserved (rev 02)
7f:02.3 Host bridge: Intel Corporation Core Processor Reserved (rev 02)
>>

Tim Gardner (timg-tpi)
affects: linux-firmware (Ubuntu) → linux (Ubuntu)
Revision history for this message
Mohegan (jack-mohegan) wrote :

Add the log (photo) when I have this kernel panic.
It seems that the problem come from "wlc_ampdu.c" at line 541.

Revision history for this message
Mohegan (jack-mohegan) wrote :

Same kernel panic with the new linux-image-2.6.38-7 !

Revision history for this message
James Schriver (dashua) wrote :

This update enabling the open source brcm80211 driver works, but is extremely unstable on my system. I can last only several minutes before a kernel panic occurs. I have to blacklist the brcm80211 module and reload the closed wl module. The brcm80211 seems to take precedence over the wl, which I already had installed. This will definitely present an issue for the common user. I have a Broadcom 43225.

I tried to get a dmesg log but it did not work. The system freeze where a cold boot is the only resolution.

Changed in linux (Ubuntu):
importance: Undecided → High
summary: - broadcom 80211 kernel panic
+ broadcom 80211 kernel panic in wlc_ampdu.c
Revision history for this message
Jeremy Foshee (jeremyfoshee) wrote :

Hi Mohegan,

Please be sure to confirm this issue exists with the latest development release of Ubuntu. ISO CD images are available from http://cdimage.ubuntu.com/daily/current/ . If the issue remains, please run the following command from a Terminal (Applications->Accessories->Terminal). It will automatically gather and attach updated debug information to this report.

apport-collect -p linux 730215

Also, if you could test the latest upstream kernel available that would be great. It will allow additional upstream developers to examine the issue. Refer to https://wiki.ubuntu.com/KernelMainlineBuilds . Once you've tested the upstream kernel, please remove the 'needs-upstream-testing' tag. This can be done by clicking on the yellow pencil icon next to the tag located at the bottom of the bug description and deleting the 'needs-upstream-testing' text. Please let us know your results.

Thanks in advance.

    [This is an automated message. Apologies if it has reached you inappropriately; please just reply to this message indicating so.]

tags: added: needs-kernel-logs
tags: added: needs-upstream-testing
tags: added: kj-triage
Changed in linux (Ubuntu):
status: New → Incomplete
Revision history for this message
Mohegan (jack-mohegan) wrote : AcpiTables.txt

apport information

tags: added: apport-collected kernel-config running-unity staging
description: updated
Revision history for this message
Mohegan (jack-mohegan) wrote : AlsaDevices.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : AplayDevices.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : BootDmesg.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : Card0.Amixer.values.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : Card0.Codecs.codec.0.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : Card1.Codecs.codec.0.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : CurrentDmesg.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : IwConfig.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : Lspci.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : Lsusb.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : PciMultimedia.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : ProcCpuinfo.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : ProcCpuinfo_.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : ProcInterrupts.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : ProcModules.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : RfKill.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : UdevDb.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : UdevLog.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote : WifiSyslog.txt

apport information

Revision history for this message
Mohegan (jack-mohegan) wrote :

Ok. It is not necessary to test the daily cdimage because I only use Natty and I make updates everey day. At this time, I use the linux-image-2.6.38-7-generic kernel (version 2.6.38-7.39).
I have made the command ("apport-collect").
If necessary, I can test some kernels.

Revision history for this message
Mohegan (jack-mohegan) wrote :

Same kernel panic with linux-image-2.6.38-8-generic.
And the network debit isn't stable.

Revision history for this message
Henry Ptasinski (hptasins) wrote :

Broadcom released a new version of firmware a couple days ago that fixes some crashes with these chips, see:

http://marc.info/?l=linux-wireless&m=130201555426946&w=2

The patches haven't been merged into the linux-firmware repo yet, and I'm not sure what Ubuntu's process is for pulling
in new firmware, but hopefully it'll help with the stability issues.

Revision history for this message
Mohegan (jack-mohegan) wrote :

Where can I find this new firmware ? I can test it.
It isn't yet in the git repository (http://git.kernel.org/?p=linux/kernel/git/dwmw2/linux-firmware.git;a=shortlog).

Revision history for this message
Henry Ptasinski (hptasins) wrote :

If you have a copy of the linux-firmware repo, apply these two patches:

http://marc.info/?l=linux-wireless&m=130201555126942&w=2
http://marc.info/?l=linux-wireless&m=130201555726958&w=2

The new firmware will be brcm/bcm43xx-0.fw and brcm/bcm43xx_hdr-0.fw.

Revision history for this message
Mohegan (jack-mohegan) wrote :

How can I apply this patch ? I found the first patch in this page https://patchwork.kernel.org/patch/694751/
but I can't find the other patch. If i create the patch file manually, it doesn't work. Any suggestion ?

Revision history for this message
Mohegan (jack-mohegan) wrote :

Another question : when will the 40MHz channels work ?

Revision history for this message
Mohegan (jack-mohegan) wrote :

If I use git apply with the second patch, It doesn't do anything with this command : " git apply --binary patch2 ".
With this command " git apply --binary -p2 brcm/patch2 ", I have this error :
" fatal: git diff header lacks filename information when removing 2 leading pathname components (line 3) ".

I add the patch at attachment

Revision history for this message
Henry Ptasinski (hptasins) wrote :

I generated the patches with "git format-patch -M", which seems to be only detecting one rename and skipping the rest. Can you try this patch with "git apply" or "git am"?

Revision history for this message
Henry Ptasinski (hptasins) wrote :

And here's the patch with the actual updated firmware.

Revision history for this message
Mohegan (jack-mohegan) wrote :

The two patch work !

For those who want test it, I did this commands :
-> git clone git://git.kernel.org/pub/scm/linux/kernel/git/dwmw2/linux-firmware.git
-> wget https://bugs.launchpad.net/ubuntu/+source/linux/+bug/730215/+attachment/2027094/+files/0002-linux-firmware-Removed-codeversion-from-brcm-firmwar.patch
-> wget https://bugs.launchpad.net/ubuntu/+source/linux/+bug/730215/+attachment/2027123/+files/0003-linux-firmware-updated-firmware-for-BCM4313-BCM43224.patch
-> cd linux-firmware
-> git am ../0002-linux-firmware-Removed-codeversion-from-brcm-firmwar.patch
-> git am ../0003-linux-firmware-updated-firmware-for-BCM4313-BCM43224.patch
-> sudo rm /lib/firmware/brcm/bcm43*
-> sudo cp brcm/* /lib/firmware/brcm/
-> sudo modprobe -r brcm80211
-> sudo modprobe brcm80211

I will test the brcm80211 all the day and say if it work or not.

Revision history for this message
Mohegan (jack-mohegan) wrote :

After testing all the day, the patch works great. No kermel panic at this time ! The network debit is stable.
But same question : when will the 40MHz channels work ?

Revision history for this message
Henry Ptasinski (hptasins) wrote :

We're currently focused on stability and code cleanup to get the driver out of staging. We have 40MHz channels, other features, and support for new chips planned but no ETA at the moment.

Revision history for this message
Mohegan (jack-mohegan) wrote :

Ok, thanks for the answer. Now, it work very well on natty !

Revision history for this message
Mohegan (jack-mohegan) wrote :

After few hours, I have a NEW KERNEL PANIC.

Revision history for this message
Henry Ptasinski (hptasins) wrote :

Which kernel package are you seeing this on? Are you still on 2.6.38-8? Several bug fixes that resolved other kernel panics went into the driver a few weeks ago. Perhaps those have not been picked up for the kernel package you're using.

Revision history for this message
Mohegan (jack-mohegan) wrote :

Ok, I will test the last kernel. But, is it possible to compile the last drivers from git with the 2.6.38 kernel ? (like this http://ubuntuforums.org/showthread.php?t=1617380 but It doesn't work for me)

Revision history for this message
James Schriver (dashua) wrote :

I've been testing for two days with the patches to linux-firmware and have not had a kernel panic yet. I will report back. Stock natty kernel 2.6.38-8-generic.

Revision history for this message
Mohegan (jack-mohegan) wrote :

For, after two weeks, I had only two kernel panics.

Revision history for this message
James Schriver (dashua) wrote :

I would have certainly had one by now. They were fairly easy to reproduce.

Revision history for this message
Henry Ptasinski (hptasins) wrote :

Some of the driver fixes deal with crashes that happen in less common usage, such as roaming in an ESS (which you would only experience if you have two or more APs in the same network).

For testing out newer driver versions with your current kernel, you could try the compat-wireless package: http://linuxwireless.org/en/users/Download . It's updated daily, but it's not pulled directly from the repo where the driver updates get submitted, so I'm not sure how much lag there is between a driver update and availability of the fix in compat-wireless.

Revision history for this message
Mohegan (jack-mohegan) wrote :

Thanks, it work with the 2.6.38 kernel. I use the linux-next compat-wireless.

I think it is up to date. No differences between http://git.kernel.org/?p=linux/kernel/git/next/linux-next.git and http://git.kernel.org/?p=linux/kernel/git/gregkh/staging-2.6.git

To compile, I use this commands :
-> ./scripts/driver-select brcm80211
-> make
-> sudo make install
-> sudo make unload
And restart the computer.

Now, I use the brcmsmac module !

Tim Gardner (timg-tpi)
Changed in linux-firmware (Ubuntu):
assignee: nobody → Tim Gardner (timg-tpi)
status: New → Fix Committed
Changed in linux (Ubuntu):
status: Incomplete → Invalid
Revision history for this message
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux-firmware - 1.52

---------------
linux-firmware (1.52) natty; urgency=low

  * Update Broadcom firmware for 2.6.38 (which requires some file
    name changes).
    -LP: #730215
 -- Tim Gardner <email address hidden> Wed, 20 Apr 2011 14:43:43 -0600

Changed in linux-firmware (Ubuntu):
status: Fix Committed → Fix Released
Revision history for this message
Steve Embling (stevene101293371) wrote :

  Ive been getting kernel panics (it appears anyway anyway, REISUB doesn't work but i do not have keyboard control lights) since this patch has been applied, after updating to 11.04 this morning...
  Once my AP went down, and ubuntu crashed immediately on connect every time until i rebooted the router.
  This was stable and worked perfectly in 10.10

Revision history for this message
Steve Embling (stevene101293371) wrote :

sorry for lack of info, this was with:
  08:00.0 Network controller: Broadcom Corporation BCM43225 802.11b/g/n (rev 01)

Revision history for this message
Henry Ptasinski (hptasins) wrote : Re: [Bug 730215] Re: broadcom 80211 kernel panic in wlc_ampdu.c
Download full text (4.1 KiB)

I assume 11.04 also brought in a new kernel and new brcm80211/brcmsmac driver.
Is there any way on ubuntu to switch to the old firmware package (from 10.10)? It would be good to know if it was the firmware or the updated driver that is
the root of the problem.

- Henry

On Fri, Apr 29, 2011 at 05:47:40AM -0700, Steve Embling wrote:
> Ive been getting kernel panics (it appears anyway anyway, REISUB doesn't work but i do not have keyboard control lights) since this patch has been applied, after updating to 11.04 this morning...
> Once my AP went down, and ubuntu crashed immediately on connect every time until i rebooted the router.
> This was stable and worked perfectly in 10.10
>
> --
> You received this bug notification because you are a direct subscriber
> of the bug.
> https://bugs.launchpad.net/bugs/730215
>
> Title:
> broadcom 80211 kernel panic in wlc_ampdu.c
>
> Status in “linux” package in Ubuntu:
> Invalid
> Status in “linux-firmware” package in Ubuntu:
> Fix Released
>
> Bug description:
> Binary package hint: linux-firmware
>
> I have many kernel panics with the brcml80211 module. My network controller is BCM43224.
> I can use my computer only few minutes with this module (but it works with another module "wl").
> ---
> AlsaVersion: Advanced Linux Sound Architecture Driver Version 1.0.23.
> Architecture: amd64
> ArecordDevices:
> **** List of CAPTURE Hardware Devices ****
> card 0: Intel [HDA Intel], device 0: STAC92xx Analog [STAC92xx Analog]
> Subdevices: 1/1
> Subdevice #0: subdevice #0
> AudioDevicesInUse:
> USER PID ACCESS COMMAND
> /dev/snd/controlC0: jack 1470 F.... pulseaudio
> CRDA: Error: [Errno 2] Aucun fichier ou dossier de ce type
> Card0.Amixer.info:
> Card hw:0 'Intel'/'HDA Intel at 0xb6100000 irq 49'
> Mixer name : 'IDT 92HD81B1X5'
> Components : 'HDA:111d7605,103c144d,00100402'
> Controls : 14
> Simple ctrls : 9
> Card1.Amixer.info:
> Card hw:1 'Generic'/'HD-Audio Generic at 0xb6020000 irq 50'
> Mixer name : 'ATI R6xx HDMI'
> Components : 'HDA:1002aa01,00aa0100,00100200'
> Controls : 4
> Simple ctrls : 1
> Card1.Amixer.values:
> Simple mixer control 'IEC958',0
> Capabilities: pswitch pswitch-joined penum
> Playback channels: Mono
> Mono: Playback [on]
> DistroRelease: Ubuntu 11.04
> HibernationDevice: RESUME=UUID=62e39a2b-d3ab-4b67-925e-005e67c1e10e
> MachineType: Hewlett-Packard HP ENVY 17 Notebook PC
> Package: linux (not installed)
> ProcEnviron:
> LANGUAGE=fr_FR:en
> LANG=fr_FR.UTF-8
> SHELL=/bin/bash
> ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-2.6.38-7-generic root=UUID=28ac122a-234c-4507-83e0-2383ba62b536 ro elevator=deadline quiet splash vt.handoff=7
> ProcVersionSignature: Ubuntu 2.6.38-7.39-generic 2.6.38
> Regression: No
> RelatedPackageVersions:
> linux-restricted-modules-2.6.38-7-generic N/A
> linux-backports-modules-2.6.38-7-generic N/A
> linux-firmware 1.49
> Reproducible: Yes
> StagingDrivers: brcm80211
> Tags: natty running-unity kernel-config needs-upstream-testing staging
> ...

Read more...

Revision history for this message
Mohegan (jack-mohegan) wrote :

Steve, you can test the Broadcom proprietary wl. Open jocky-gtk and install the Broadcom STA driver (like the ubuntu 10.10). Reboot : it deactivates the brcm80211 driver.

To post a comment you must log in.